/**
 * 
 */
package edu.stanford.multiagent.gamer;

import java.io.*;
import java.nio.IntBuffer;
import java.util.*;

import edu.stanford.multiagent.gamer.graphs.*;

/**
 * @author Gesa Ohlendorf
 * Bayes Action Graph Game abstract class
 *
 */
public abstract class BayesActionGraphGame extends ActionGraphGame {
	
    protected double[][] typeDistributions; 	// new (N rows, each row has |Theta_i| real values
    protected int[][][] typeActionSets;			// renamed (|Theta| rows with |A_theta| integers (AN indices) in ascending order)
    
	/**
	 * Constructor for a new BAGG
	 * @throws Exception
	 */
	public BayesActionGraphGame() throws Exception {
		super();
	}
	
	 /**
     * Sets the number of players based on the command line parameter.
     */
    public void initialize()
	throws Exception
    {
	super.initialize();
	
    }
    
    @Override
    /**
     * Output the game in BAGG format. 
     * @see edu.stanford.multiagent.gamer.Game#writeGame(java.io.PrintWriter)
     */
    public void writeGame (PrintWriter out)
    {

	    //identifier string
	    out.println("#BAGG");
	    
		out.println( "# Generated by " + Global.VERSION_STRING);
	
		out.println(SpecialOutput.commentString(getDescription(), "# "));
		
		//num of players
		out.println("\n#The number of Players, n:");
		out.println( getNumPlayers() );
	
		//num of action nodes
		out.println("#The number of action nodes, |S|:");
		out.println( numActionNodes);
		//num of func nodes
		out.println("#The number of function nodes, |P|:");
		out.println (numPNodes);
	
		//sizes of types
		out.println("\n#Thenumber of types for each player:");
		for (int i=0;i<getNumPlayers(); i++){
		  out.print(typeDistributions[i].length + " ");
		}
		//type distribution
		out.println("\n\n#Type distribution for each player:");
		for (int i=0;i<getNumPlayers();i++){
		  for (int j=0; j<typeDistributions[i].length; j++){
		    out.print(typeDistributions[i][j] + " ");
		  }
		  out.print("\n");
		}
		//sizes of type-action sets
		out.println("\n#Size of type-action set for each player's each type:");
		for (int i=0;i<getNumPlayers(); i++){
			for (int j=0; j<typeActionSets[i].length; j++){
			    out.print(typeActionSets[i][j].length + " ");
			}
			out.print("\n");
		}
		//action sets
		out.println("\n#Type-action set for each player's each type:");
		for (int i=0;i<getNumPlayers();i++){
		  for (int j=0; j<typeActionSets[i].length; j++){
			  for(int k=0; k<typeActionSets[i][j].length; k++) {
				  out.print(typeActionSets[i][j][k] + " ");
			  }
			  out.print("\n");
		  }
		}
		//action graph
		out.println("\n#The action graph:");
		for(int i=0;i<numActionNodes+numPNodes; i++){
		  Iterator edgeIter = graph.getEdges(i);
		  //first output the number of neighbors
		  out.print(graph.getNumNeighbours(i));
		  while (edgeIter.hasNext()){
		    Edge e= (Edge) edgeIter.next();
		    int neighborNode=e.getDest();
	
		    out.print(" " + neighborNode);
		  }
		  out.print("\n");
	
		}
	
		// the types for the func nodes
		out.println("\n#The types of function nodes:");
		writePTypes(out);
		//payoffs
		out.println("\n#The payoffs:");
		writePayoffs(out);
	
		out.flush();
    }
}
